#ifndef BDP_H
#define BDP_H

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include "uthash.h"
#include "ice.h"
#include "file.h"

typedef struct{
	long number;
	long hash;
	long size;
} PazFile;

typedef struct
{
    long hash;
    long folderNum;
    long fileNum;
    long pazNum;
    long offset;
    long zsize;
    long size;
} FileBlock;

typedef struct
{
	long num;
	long sub;
	char* name;
} FolderName;

typedef struct{
	char* path;
	long fileBlockNum;
	UT_hash_handle hh;
} PathHash;

#define MAGIC "\x51\xF3\x0F\x11\x04\x24\x6A\x00"

extern int DEBUG;
extern int EMULATE;
extern const char** searchPath;

extern ICE_KEY *ik;

extern long clientVersion;
extern long pazCount;
extern long fileCount;
extern PazFile *pazFile;
extern FileBlock *fileBlock;
extern FolderName *folderName;
extern char **filename;
extern PathHash *pathHash;

extern long folderSize;
extern long fileSize;

#endif // BDP_H
