#include <string.h>
#include "bdp.h"
#include "confuse.h"

#define VER_MAJ 0
#define VER_MIN 1
#define VER_FIX 0
#define VER_STR "0.1.0"

#define passOrExit(function) if (function){ \
	printf(" Quit...."); \
	return 1; \
}

int DEBUG, EMULATE;
const char** searchPath;

int loadConfig(){
	searchPath = (const char**) calloc(64, 50);

	cfg_opt_t opts[] =
	{
			CFG_BOOL("debug", cfg_false, CFGF_NONE),
			CFG_BOOL("emulate", cfg_true, CFGF_NONE),
			CFG_STR_LIST("searchPath", "{\"\"}", CFGF_NONE),
			CFG_END()
	};

	cfg_t *cfg = cfg_init(opts, CFGF_NONE);
	if(cfg_parse(cfg, "BDP_BACKUP\\configure.txt") == CFG_PARSE_ERROR){
		return 1;
	}

	DEBUG = cfg_getbool(cfg, "debug");
	EMULATE = cfg_getbool(cfg, "emulate");
	for(int i = 0; i < cfg_size(cfg, "searchPath"); i++){
		*(searchPath+i) = cfg_getnstr(cfg, "searchPath", i);
	}
	//cfg_free(cfg);

	return 0;
}

void printHeader(){
	printf("******************************************************\n");
    printf("*                                                    *\n");
    printf("*                Black Desert Patcher                *\n");
    printf("*                                            v%5s  *\n", VER_STR);
    printf("*                                                    *\n");
    printf("* fork from                                          *\n");
    printf("*       \"Meta Injector Reloaded v1.6\" by BlackfireBR *\n");
    printf("******************************************************\n");
    if(DEBUG){
    	printf("                                     debug mode [ON]\n");
    }
}

void pressToContinue(){
	printf("\n\n\n");
	printf("Now, open Black Desert Launcher and wait patch finish, then ");
	system("pause");
}

int main(){
	passOrExit(loadConfig());
	printHeader();

	printf("Restore backup\n");
	simpleRestore();

	passOrExit(init());
	pressToContinue();
	printf("\n\n\n");

	printf("Backup original file\n");
	simpleBackup();

	patch();
	cleanUp();

	system("pause");

	return 0;
}
