#include "bdp.h"
#include <time.h>
#include <dirent.h>

FILE *mod;
char* fakeFolderName;
long foldernameCount;
int patchCallCount = 0;
int patchSuccessCount = 0;

void basicDump(){
	char* buffer;
	mod = fopen("Paz\\pad00000.meta", "wb");
	fwrite(&clientVersion, 4, 1, mod);
	fwrite(&pazCount, 4, 1, mod);
	for(int i = 0; i < pazCount; i++){
		fwrite(&pazFile[i].number, 4, 1, mod);
		fwrite(&pazFile[i].hash, 4, 1, mod);
		fwrite(&pazFile[i].size, 4, 1, mod);
	}

	fwrite(&fileCount, 4, 1, mod);
	buffer = (char*) calloc(1, 256000);
	FILE *unknown = fopen("BDP_BACKUP\\unknown.dat", "rb");
	fread(buffer, 1, 256000, unknown);
	fwrite(buffer, 1, 256000, mod);
	free(buffer);
	fclose(unknown);
}

char* indexInjection(const char* fullPath){
	char *info = "[FAIL]";
	if(DEBUG){
		PathHash *s;
		FILE *hashList = fopen("BDP_BACKUP\\hashList.csv", "w");
		for(s = pathHash; s != NULL; s = (PathHash *)s->hh.next){
			fprintf(hashList, "%s,%ld\n", s->path, s->fileBlockNum);
		}
		fclose(hashList);
	}

	patchCallCount++;
	PathHash *result = (PathHash*) calloc(1, sizeof(PathHash));
	HASH_FIND_STR(pathHash, fullPath, result);

	if(result != NULL){
		info = (char *) calloc(1, 32);
		if(DEBUG){
			sprintf(info, "[SUCCESS] id: %ld", result->fileBlockNum);
		} else {
			info = "[SUCCESS]";
		}
		fileBlock[result->fileBlockNum].folderNum = foldernameCount;
		patchSuccessCount++;
	}

	return info;
}

void listFile(const char *name, int level)
{
    DIR *dir;
    struct dirent *entry;
    char *fullPath = (char*) calloc(1, 256);

    if (!(dir = opendir(name)))
        return;
    if (!(entry = readdir(dir)))
        return;

    do {
        if (entry->d_type == DT_DIR) {
            char path[1024];
            int len = snprintf(path, sizeof(path)-1, "%s/%s", name, entry->d_name);
            path[len] = 0;
            if (strcmp(entry->d_name, ".") == 0 || strcmp(entry->d_name, "..") == 0)
                continue;
            //sprintf(entry->d_name, "%s/", entry->d_name);
            listFile(path, level + 1);
        }
        else
            sprintf(fullPath, "%s/%s",name, entry->d_name);
        if(*fullPath){
        	printf("%-60s - %s\n",fullPath, indexInjection(fullPath));
        }
    } while (entry = readdir(dir));
    closedir(dir);
}

void readAndEncrypt(char* path){
	FILE *inputFile = fopen(path, "rb");
	fseek(inputFile, 0, SEEK_END); // seek to end of file
	long length = ftell(inputFile); // get current file pointer
	if(length % 8){
		length = length - length % 8 + 8;
	}
	fseek(inputFile, 0, SEEK_SET); // seek back to beginning of file

	long cuts = length / 8;
	char *buffer;
	fwrite(&length, 4, 1, mod);
	while(cuts--){
		buffer = (char *) calloc(1, 8);
		fread(buffer, 8, 1, inputFile);
		ice_key_encrypt(ik, buffer, buffer);
		fwrite(buffer, 8, 1, mod);
	}
	fclose(inputFile);
}

void searchAndPatch(){
	int count = 0;
	while(*(searchPath+count)){
		listFile(*(searchPath+count), 0);
		count++;
	}

	long clearFileCount = fileCount - 8000;
	for(int i = 0; i < clearFileCount; i++){
		fwrite(&fileBlock[i].hash, 4, 1, mod);
		fwrite(&fileBlock[i].folderNum, 4, 1, mod);
		fwrite(&fileBlock[i].fileNum, 4, 1, mod);
		fwrite(&fileBlock[i].pazNum, 4, 1, mod);
		fwrite(&fileBlock[i].offset, 4, 1, mod);
		fwrite(&fileBlock[i].zsize, 4, 1, mod);
		fwrite(&fileBlock[i].size, 4, 1, mod);
	}

	if(patchCallCount){
		printf("\nResult: %d/%d patched!\n\n", patchSuccessCount, patchCallCount);
	}
	readAndEncrypt("BDP_BACKUP\\folderPlainDump.dat");
	readAndEncrypt("BDP_BACKUP\\filePlainDump.dat");
}

void fakeFolderNameGenerate(){
	srand((unsigned int) time(NULL));
	fakeFolderName = (char*) calloc(1, 17);
	int foldernameLength = rand() % 16;
	*(fakeFolderName+foldernameLength) = '/';
	for (int i = 0; i < foldernameLength; i++){
		*(fakeFolderName+i) = rand() % 26 + 97;
	}
	if(DEBUG){
		printf("fake folder name: %s", fakeFolderName);
	}
}

void prepareEncrypt(){
	FILE *folderPlainText = fopen("BDP_BACKUP\\folderPlainDump.dat", "wb");
	FILE *filePlainText = fopen("BDP_BACKUP\\filePlainDump.dat", "wb");
	char* dummyByte = (char*) calloc(1, 8);

	long foldernameSize = 0;
	while(folderName[foldernameCount].sub){
		foldernameSize += fwrite(&folderName[foldernameCount].num, 1, 4, folderPlainText);
		foldernameSize += fwrite(&folderName[foldernameCount].sub, 1, 4, folderPlainText);
		foldernameSize += fwrite(folderName[foldernameCount].name, 1, strlen(folderName[foldernameCount].name)+1, folderPlainText);
		foldernameCount++;
	}
	foldernameCount--;

	if(EMULATE){
		long fakeFolderNum = folderName[foldernameCount].num + folderName[foldernameCount].sub;
		long fakeFolderSub = 1;

		foldernameSize += fwrite(&fakeFolderNum, 1, 4, folderPlainText);
		foldernameSize += fwrite(&fakeFolderSub, 1, 4, folderPlainText);
		foldernameSize += fwrite(fakeFolderName, 1, strlen(fakeFolderName)+1, folderPlainText);

		if(foldernameSize % 8){
			fwrite(dummyByte, 1, 8 - (foldernameSize % 8), folderPlainText);
		}
		foldernameCount++;
	}

	long filenameCount = 0;
	long filenameSize = 0;
	while(*(filename+filenameCount)){
		filenameSize += fwrite(*(filename+filenameCount), 1, strlen(*(filename+filenameCount))+1, filePlainText);
		filenameCount++;
	}
	if(filenameSize % 8){
		fwrite(dummyByte, 1, 8 - (filenameSize % 8), filePlainText);
	}

	fclose(folderPlainText);
	fclose(filePlainText);

}

int patch(){

	if(EMULATE){
		fakeFolderNameGenerate();
	}
	prepareEncrypt();
	basicDump();
	searchAndPatch();

	return 0;
}
